<?php
//
// jQuery File Tree PHP Connector
//
// Version 1.01
//
// Cory S.N. LaViska
// A Beautiful Site (http://abeautifulsite.net/)
// 24 March 2008
//
// History:
//
// 1.01 - updated to work with foreign characters in directory/file names (12 April 2008)
// 1.00 - released (24 March 2008)
//
// Output a list of files for jQuery File Tree
//

session_start();

header("Content-Type: text/plain");

if(!isset($_SESSION["editor_logged"]) OR ($_SESSION["editor_logged"] == FALSE))
    die("Not logged in!");

//echo $_SESSION["editor_user_name"];

require_once __DIR__ . '/../../config.php';

$root = "../../../";
$_POST['dir'] = urldecode($_POST['dir']);

if( file_exists($root . $_POST['dir']) && ($_POST['dir'] != "./") ) {
	$files = scandir($root . $_POST['dir']);
	natcasesort($files);
	if( count($files) > 2 ) { /* The 2 accounts for . and .. */
		echo "<ul id=\"myTree\" class=\"jqueryFileTree\" style=\"display: none;\">";
        
        if(($_POST['dir'] == "/"))
            echo '<li class="directory collapsed"><a href="#" rel="./">./ (this dir)</a></li>';
		// All dirs
		foreach( $files as $file ) {
			if( file_exists($root . $_POST['dir'] . $file) && $file != '.' && $file != '..' && is_dir($root . $_POST['dir'] . $file) ) {
				if(!in_array($_POST['dir'] . $file, $configuration['excludeDirs']))
					echo "<li class=\"directory collapsed\"><a href=\"#\" rel=\"" . htmlentities($_POST['dir'] . $file) . "/\">" . htmlentities($file) . "</a></li>";
			}
		}
		// All files
		foreach( $files as $file ) {
			if( file_exists($root . $_POST['dir'] . $file) && $file != '.' && $file != '..' && !is_dir($root . $_POST['dir'] . $file) ) {
				$ext = preg_replace('/^.*\./', '', $file);
				if(!in_array($_POST['dir'] . $file, $configuration['excludeFiles']))
					echo "<li class=\"file ext_$ext\"><a href=\"#\" data-file-location=\"" . htmlentities($_POST['dir'] . $file) . "\" ondblclick=\"openFile(this, false)\" rel=\"" . htmlentities($_POST['dir'] . $file) . "\">" . htmlentities($file) . "</a></li>";
			}
		}
		echo "</ul>";	
	} elseif(($_POST['dir'] == "/"))
    {
        echo "<ul class=\"jqueryFileTree\" style=\"display: none;\">";
        echo '<li class="directory collapsed"><a href="#" rel="./">./ (this dir)</a></li>';
        echo "</ul>";        
    }
}
