<?php

/**
 * FBC Editor
 * Your online php editor.
 * 
 * @version 0.3
 * @package FBCEditor
 * @author Polasek Frantisek (PolasekF@gmail.com)
 * @copyright 2013 Polasek Frantisek
 */

@set_magic_quotes_runtime(false);

session_start();

header("Content-Type: text/plain");

if (!isset($_SESSION["editor_logged"]) or ($_SESSION["editor_logged"] == false))
	die("Not logged in!");

require_once 'SafeStream.php';
SafeStream::register();

function deleteDirectory($dir)
{
	if (!file_exists($dir))
		return true;
	if (!is_dir($dir) || is_link($dir))
		return unlink($dir);
	foreach (scandir($dir) as $item)
	{
		if ($item == '.' || $item == '..')
			continue;
		if (!deleteDirectory($dir . "/" . $item))
		{
			chmod($dir . "/" . $item, 0777);
			if (!deleteDirectory($dir . "/" . $item))
				return false;
		}
		;
	}

	return rmdir($dir);
}

function upload_errors($err_code)
{
	switch ($err_code)
	{
		case UPLOAD_ERR_INI_SIZE:
			return 'The uploaded file exceeds the upload_max_filesize directive in php.ini';
		case UPLOAD_ERR_FORM_SIZE:
			return 'The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form';
		case UPLOAD_ERR_PARTIAL:
			return 'The uploaded file was only partially uploaded';
		case UPLOAD_ERR_NO_FILE:
			return 'No file was uploaded';
		case UPLOAD_ERR_NO_TMP_DIR:
			return 'Missing a temporary folder';
		case UPLOAD_ERR_CANT_WRITE:
			return 'Failed to write file to disk';
		case UPLOAD_ERR_EXTENSION:
			return 'File upload stopped by extension';
		default:
			return 'Unknown upload error';
	}
}

if (isset($_POST["operation"]) && $_POST["operation"] == 'open')
{
	$myFile = "../." . $_REQUEST["file"];

	if (filesize($myFile) != 0)
	{
		echo file_get_contents('safe://' . $myFile);
	}
} elseif (isset($_POST["operation"]) && $_POST["operation"] == 'save')
{
	if (!(file_put_contents('safe://' . "../." . $_REQUEST["file"], $_POST["data"])))
		echo "err";
	else
		echo "ok";
} elseif (isset($_POST["operation"]) && $_POST["operation"] == 'createFile')
{
	if ($_POST["dir"] == "./")
		$_POST["dir"] = "/";
	if (!file_exists("../." . $_POST["dir"] . $_POST["file"]))
		file_put_contents("../." . $_POST["dir"] . $_POST["file"], "");
} elseif (isset($_POST["operation"]) && $_POST["operation"] == 'createFolder')
{
	if ($_POST["dir"] == "./")
		$_POST["dir"] = "/";

	if (!file_exists("../." . $_POST["dir"] . $_POST["file"]))
	{
		$oldumask = umask(0);
		mkdir("../." . $_POST["dir"] . $_POST["file"], 0777);
		umask($oldumask);
	}
} elseif (isset($_POST["operation"]) && $_POST["operation"] == 'removeFile')
{
	var_dump($_POST);
	if (file_exists("../." . $_POST["file"]))
	{
		unlink("../." . $_POST["file"]);
	}
} elseif (isset($_POST["operation"]) && $_POST["operation"] == 'removeFolder')
{
	if ($_POST["dir"] == "./")
		$_POST["dir"] = "/";
	//var_dump($_POST);
	if (file_exists("../." . $_POST["dir"]))
	{
		deleteDirectory("../." . $_POST["dir"]);
	}
} elseif (isset($_POST["operation"]) && $_POST["operation"] == 'renameFile')
{
	if ($_POST["dir"] == "./")
		$_POST["dir"] = "/";

	$oldPath = "../." . $_POST["dir"];
	$newPath = "../." . str_replace($_POST["oldFile"], "", $_POST["dir"]) . $_POST["file"];

	if (file_exists($oldPath))
	{
		rename($oldPath, $newPath);
	}
} elseif (isset($_POST["operation"]) && $_POST["operation"] == 'renameFolder')
{
	if ($_POST["dir"] == "./")
		$_POST["dir"] = "/";
	//var_dump($_POST);
	$oldPath = substr_replace("../." . $_POST["dir"], "", -1);
	$newPath = "../." . str_replace($_POST["oldFile"] . '/', "", $_POST["dir"]) . $_POST["file"];

	if (file_exists($oldPath))
	{
		rename($oldPath, $newPath);
	}
} elseif (isset($_GET["operation"]) && $_GET["operation"] == 'download')
{
	$file = __DIR__ . "/.." . $_GET['file'];
	if (file_exists($file))
	{
		header('Content-Description: File Transfer');
		header('Content-Type: application/octet-stream');
		header('Content-Disposition: attachment; filename=' . basename($file));
		header('Content-Transfer-Encoding: binary');
		header('Expires: 0');
		header('Cache-Control: must-revalidate');
		header('Pragma: public');
		header('Content-Length: ' . filesize($file));
		ob_clean();
		flush();
		readfile($file);
		exit;
	}

} elseif (isset($_GET["operation"]) && $_GET["operation"] == 'upload')
{
	$UploadDirectory = __DIR__ . "/../" . $_POST['mName']; //Upload Directory, ends with slash & make sure folder exist


	if (!@file_exists($UploadDirectory))
	{
		//destination folder does not exist
		die("Make sure Upload directory exist!");
	}

	if ($_POST)
	{

		if (!isset($_FILES['mFile']))
		{
			//required variables are empty
			die("File is empty!");
		}


		if ($_FILES['mFile']['error'])
		{
			//File upload error encountered
			die(upload_errors($_FILES['mFile']['error']));
		}

		$FileName = strtolower($_FILES['mFile']['name']); //uploaded file name

		$NewFileName = $_FILES['mFile']['name'];
		//Rename and save uploded file to destination folder.
		if (move_uploaded_file($_FILES['mFile']["tmp_name"], $UploadDirectory . $NewFileName))
		{

			die('Success! File Uploaded.');

		} else
		{
			die('error uploading File!');
		}
	}
}

